/*--------------------------------------------------------------------*/
/* H8S,H8/300 SERIES C Compiler Ver. 1.0                              */
/* Copyright (C) 1994 Hitachi, Ltd.                                   */
/* Licensed Material of Hitachi,Ltd.                                  */
/*--------------------------------------------------------------------*/
/***********************************************************************/
/* SPEC;                                                               */
/*  NAME = _alocbuf : allocate i/o buffer for file stream;             */
/*                                                                     */
/*  FUNC = this module do the following functions;                     */
/*         (1) get buffer area;                                        */
/*         (2) initialize buffer status;                               */
/*         (3) alloc big buffer or small buffer for the file stream;   */
/*                                                                     */
/*  CLAS = UNIT;                                                       */
/*                                                                     */
/* END;                                                                */
/***********************************************************************/

#define  _IOPROT   1
#include "lstdio.h"
#include "lstdlib.h"
#include "h2lfun.h"
#include "e_alocb.h"

void _alocbuf(stream)
FILE *stream;
{
                                     /*  V-------------------- 3V4027 */
/** static unsigned char sml_buf[_NFILE]; * 1 byte buffer D P3V252-1L */
    void   *fnc_rc;                     /* calloc function return code */


    if (stream->_bufbase==0){           /* if not allocate buffer ? */
        if (flgck1(stream,_IOUNBUF)==0){/* if normal buffering mode ? */
            fnc_rc = malloc((size_t)BUFSIZ);  /* yes: */
            if (fnc_rc!=0){             /* if buffer allocate complete ? */
                stream->_bufbase = (unsigned char*)fnc_rc;
                stream->_buflen  = BUFSIZ;  /* set buffer size */
                stream->_ioflag1 |= _IOBGBUF; /* set "allocate buffer" flag */
            }
            else{                       /* buffer allocate uncomplete */
                stream->_bufbase=(unsigned char*)
                        &sml_buf[stream->_iofd]; /* alloc small buf */
                stream->_buflen = 1;    /* buffer length is 1 byte */
            }
        }
        else{                           /* unbuffering mode( _IOUNBUF on) */
            stream->_bufbase =(unsigned char*)
                    &sml_buf[stream->_iofd];    /* alloc small buf */
            stream->_buflen = 1;        /* buffer length is 1 byte */
        }
        /* initialize buffer pointer and counter */
        if (flgck1(stream,_IOREAD)!=0){ /* if input mode buffer ? */
            stream->_bufptr = stream->_bufbase+stream->_buflen;
            stream->_bufcnt = 0;
        }
        if (flgck1(stream,_IOWRITE)!=0){/* if output mode buffer ? */
            stream->_bufptr = stream->_bufbase;
            stream->_bufcnt = stream->_buflen;
        }

    }

}
